热门标签 | HotTags
当前位置:  开发笔记 > 编程语言 > 正文

rubyonrails代码技巧

对于rails的一些使用技巧的代码

git仓库输出
git archive --format=tar --prefix=actasfavor/ HEAD | (cd /home/holin/work/ && tar xf -)
输出到/home/holin/work/actasfavor/目录下

Posted by holin At May 16, 2008 16:42
加载plugins中的controller和model

# Include hook code here
require 'act_as_favor'
# make plugin controller, model, helper available to app
config.load_paths += %W(#{ActAsFavor::PLUGIN_CONTROLLER_PATH} #{ActAsFavor::PLUGIN_HELPER_PATH} #{ActAsFavor::PLUGIN_MODELS_PATH})
Rails::Initializer.run(:set_load_path, config)
# require the controller
require 'favors_controller'
# require models
require 'favor'

Posted by holin At May 15, 2008 15:36
使用最频繁的前5个命令
history | awk {'print $2'} | sort | uniq -c | sort -k1 -rn| head -n5

Posted by holin At May 15, 2008 10:40
按数组元素的某属性排序
@users.sort!{|a, b| a.last <=> b.last }

Posted by holin At May 11, 2008 14:35
按日期备份数据库
mysqldump db_name -uroot > "/root/db_backup/kaoshi_web_`date +"%Y-%m-%d"`.sql"

Posted by holin At May 08, 2008 12:05
用memcached手动cache数据

sql = "SELECT * FROM blogs LIMIT 100"
Blog.class
k = MD5.new(sql)
@blogs = Cache.get k
if @blogs.blank?
@blogs = Blog.find_by_sql(sql)
Cache.put k, @blogs, 60*30 #expire after 30min
end
memcache-client 1.5.0:
get(key, expiry = 0)
put(key, value, expiry = 0)

Posted by devon At May 04, 2008 20:39
shuffle an array

class Array
def shuffle
sort_by { rand }
end
def shuffle!
self.replace shuffle
end
end

Posted by holin At May 04, 2008 15:39
让所有的ajax请求都不render :layout

def render(*args)
args.first[:layout] = false if request.xhr? and args.first[:layout].nil?
super
end

Posted by devon At May 03, 2008 10:53
Find with Hash

Event.find(
:all,
:cOnditions=> [ "title like :search or description like :search",
{:search => "%Tiki%"}]
)

Posted by devon At May 03, 2008 10:49
执行sql语句脚本

mysql -uroot -p123<use dbame;
delete from results;
delete from examings;
quit
END

Posted by holin At May 01, 2008 12:14
SQL Transaction in Rails

def fetch_value
sql = ActiveRecord::Base.connection();
sql.execute "SET autocommit=0";
sql.begin_db_transaction
id, value =
sql.execute("SELECT id, value FROM sometable WHERE used=0 LIMIT 1 FOR UPDATE").fetch_row;
sql.update "UPDATE sometable SET used=1 WHERE id=#{id}";
sql.commit_db_transaction
value;
end

Posted by holin At April 30, 2008 09:37
显示 Flash 消息的动态效果

<% if flash[:warning] or flash[:notice] %>

class="warning"<% end %>>
<%= flash[:warning] || flash[:notice] %>
<% end %>
15000 毫秒后自动 notice Div 自动消失。

Posted by devon At April 29, 2008 13:02
删除环境中的常量

Object.send(:remove_const, :A)
>> Math
=> Math
>> Object.send(:remove_const, :Math)
=> Math
>> Math
NameError: uninitialized constant Math

Posted by devon At April 28, 2008 18:24
手动加上 authenticity_token


Posted by devon At April 28, 2008 14:24
Rails group_by

<% @articles.group_by(&:day).each do |day, articles| %>

<%= day.to_date.strftime('%y年%m月%d日') %>


<%= render :partial => 'article', :collection => articles %>

<% end %>
articles 按天数分组

Posted by devon At April 25, 2008 22:32
读写文件

# Open and read from a text file
# Note that since a block is given, file will
# automatically be closed when the block terminates
File.open('p014constructs.rb', 'r') do |f1|
while line = f1.gets
puts line
end
end
# Create a new file and write to it
File.open('test.rb', 'w') do |f2|
# use "\n" for two lines of text
f2.puts "Created by Satish\nThank God!"
end

Posted by holin At April 17, 2008 02:10
遍历目录
Dir.glob(File.join('app/controllers', "**", "*_controller.rb")) { |filename| puts filename }

Posted by holin At April 16, 2008 15:28
字符串到 model
1
2
>> 'tag_course'.camelize.constantize.find(:first)
=> #
*camelize(lower_case_and_underscored_word, first_letter_in_uppercase = true)*
By default, camelize converts strings to UpperCamelCase. If the argument to camelize is set to ":lower" then camelize produces lowerCamelCase.
*constantize(camel_cased_word)*
Constantize tries to find a declared constant with the name specified in the string. It raises a NameError when the name is not in CamelCase or is not initialized.

Posted by devon At April 07, 2008 17:32
调用Proc
1
2
3
a = Proc.new { |i| puts i }
a['haha']
a.call('hehe')

Posted by holin At March 28, 2008 23:10
Rails中Host静态文件
1
2
config.action_controller.asset_host = "http://assets.example.com"
config.action_controller.asset_host = "http://assets-%d.example.com"
The Rails image_path and similar helper methods will then use that host to reference files in the public directory.
The second line will distribute asset requests across assets-0.example.com,assets-1.example.com, assets-2.example.com, and assets-3.example.com.

Posted by devon At March 26, 2008 18:18
打包gems到项目目录中

$ mkdir vendor/gems
$ cd vendor/gems
$ gem unpack hpricot
Unpacked gem: 'hpricot-0.4'
config.load_paths += Dir["#{RAILS_ROOT}/vendor/gems/**"].map do |dir|
File.directory?(lib = "#{dir}/lib") ? lib : dir
end

Posted by devon At March 26, 2008 18:12
在当前上下文中执行文件中的代码

instance_eval(File.read('param.txt'))
# such as
@father = 'Father'
instance_eval("puts @father")
#Produces:
#Father

Posted by holin At March 20, 2008 01:13
将当前文件所在目录加入require路径

$LOAD_PATH <# or
$: <# this one puts current path before the other path.
$:.unshift( File.expand_path(File.dirname(__FILE__)) )
*__ FILE __* 当前文件路径

Posted by holin At March 19, 2008 01:40
多字段模糊搜索

cOnditions= []
[:name, :school, :province, :city].each { |attr| conditions <cOnditions= conditions.any? ? conditions.collect { |c| "(#{c})" }.join(' OR ') : nil
在profile表里,按name, school, province, city模糊搜索

Posted by devon At March 17, 2008 17:25
nginx 启动脚本


#! /bin/sh
# chkconfig: - 58 74
# description: nginx is the Nginx daemon.
# Description: Startup script for nginx webserver on Debian. Place in /etc/init.d and
# run 'sudo update-rc.d nginx defaults', or use the appropriate command on your
# distro.
#
# Author: Ryan Norbauer
# Modified: Geoffrey Grosenbach http://topfunky.com
# Modified: David Krmpotic http://davidhq.com
set -e
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="nginx daemon"
NAME=nginx
DAEMON=/usr/local/nginx/sbin/$NAME
COnFIGFILE=/usr/local/nginx/conf/nginx.conf
DAEMON=/usr/local/nginx/sbin/$NAME
COnFIGFILE=/usr/local/nginx/conf/nginx.conf
PIDFILE=/usr/local/nginx/logs/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Gracefully exit if the package has been removed.
test -x $DAEMON || exit 0
d_start() {
$DAEMON -c $CONFIGFILE || echo -en "\n already running"
}
d_stop() {
kill -QUIT `cat $PIDFILE` || echo -en "\n not running"
}
d_reload() {
kill -HUP `cat $PIDFILE` || echo -en "\n can't reload"
}
case "$1" in
start)
echo -n "Starting $DESC: $NAME"
d_start
echo "."

stop)
echo -n "Stopping $DESC: $NAME"
d_stop
echo "."

reload)
echo -n "Reloading $DESC configuration..."
d_reload
echo "."

restart)
echo -n "Restarting $DESC: $NAME"
d_stop
# One second might not be time enough for a daemon to stop,
# if this happens, d_start will fail (and dpkg will break if
# the package is being upgraded). Change the timeout if needed
# be, or change d_stop to have start-stop-daemon use --retry.
# Notice that using --retry slows down the shutdown process
# somewhat.
sleep 1
d_start
echo "."

*)
echo "Usage: $SCRIPTNAME {start|stop|restart|reload}" >&2
exit 3

esac
exit 0
将文件写入到 /etc/init.d/nginx
sudo chmod +x /etc/init.d/nginx
测试是否可正确运行
sudo /etc/init.d/nginx start
设置自动启动
sudo /sbin/chkconfig --level 345 nginx on

Posted by devon At March 16, 2008 12:26
link_to_remote 取静态页面
1
2
<%= link_to_remote "update post", :update => 'post', :method => 'get', :url => '/post_1.html' %>

将 url 改为静态面页的地址即可。

Posted by devon At March 16, 2008 11:07
in_place_editor for rails2.0

module InPlaceMacrosHelper
# Makes an HTML element specified by the DOM ID +field_id+ become an in-place
# editor of a property.
#
# A form is automatically created and displayed when the user clicks the element,
# something like this:
#
#
#
# cancel
#
#
# The form is serialized and sent to the server using an AJAX call, the action on
# the server should process the value and return the updated value in the body of
# the reponse. The element will automatically be updated with the changed value
# (as returned from the server).
#
# Required +options+ are:
# :url:: Specifies the url where the updated value should
# be sent after the user presses "ok".
#
# Addtional +options+ are:
# :rows:: Number of rows (more than 1 will use a TEXTAREA)
# :cols:: Number of characters the text input should span (works for both INPUT and TEXTAREA)
# :size:: Synonym for :cols when using a single line text input.
# :cancel_text:: The text on the cancel link. (default: "cancel")
# :save_text:: The text on the save link. (default: "ok")
# :loading_text:: The text to display while the data is being loaded from the server (default: "Loading...")
# :saving_text:: The text to display when submitting to the server (default: "Saving...")
# :external_control:: The id of an external control used to enter edit mode.
# :load_text_url:: URL where initial value of editor (content) is retrieved.
# :options:: Pass through options to the AJAX call (see prototype's Ajax.Updater)
# :with:: Javascript snippet that should return what is to be sent
# in the AJAX call, +form+ is an implicit parameter
# :script:: Instructs the in-place editor to evaluate the remote Javascript response (default: false)
# :click_to_edit_text::The text shown during mouseover the editable text (default: "Click to edit")
def in_place_editor(field_id, optiOns= {})
function = "new Ajax.InPlaceEditor("
function <<"'#{field_id}', "
function <<"'#{url_for(options[:url])}'"
js_optiOns= {}
if protect_against_forgery?
options[:with] ||= "Form.serialize(form)"
options[:with] += " + '&authenticity_token=' + encodeURIComponent('#{form_authenticity_token}')"
end
js_options['cancelText'] = %('#{options[:cancel_text]}') if options[:cancel_text]
js_options['okText'] = %('#{options[:save_text]}') if options[:save_text]
js_options['loadingText'] = %('#{options[:loading_text]}') if options[:loading_text]
js_options['savingText'] = %('#{options[:saving_text]}') if options[:saving_text]
js_options['rows'] = options[:rows] if options[:rows]
js_options['cols'] = options[:cols] if options[:cols]
js_options['size'] = options[:size] if options[:size]
js_options['externalControl'] = "'#{options[:external_control]}'" if options[:external_control]
js_options['loadTextURL'] = "'#{url_for(options[:load_text_url])}'" if options[:load_text_url]
js_options['ajaxOptions'] = options[:options] if options[:options]
# js_options['evalScripts'] = options[:script] if options[:script]
js_options['htmlResponse'] = !options[:script] if options[:script]
js_options['callback'] = "function(form) { return #{options[:with]} }" if options[:with]
js_options['clickToEditText'] = %('#{options[:click_to_edit_text]}') if options[:click_to_edit_text]
js_options['textBetweenControls'] = %('#{options[:text_between_controls]}') if options[:text_between_controls]
function <<(', ' + options_for_Javascript(js_options)) unless js_options.empty?
function <<')'
Javascript_tag(function)
end
# Renders the value of the specified object and method with in-place editing capabilities.
def in_place_editor_field(object, method, tag_optiOns= {}, in_place_editor_optiOns= {})
tag = ::ActionView::Helpers::InstanceTag.new(object, method, self)
tag_optiOns= {:tag => "span", :id => "#{object}_#{method}_#{tag.object.id}_in_place_editor", :class => "in_place_editor_field"}.merge!(tag_options)
in_place_editor_options[:url] = in_place_editor_options[:url] || url_for({ :action => "set_#{object}_#{method}", :id => tag.object.id })
tag.to_content_tag(tag_options.delete(:tag), tag_options) +
in_place_editor(tag_options[:id], in_place_editor_options)
end
end
解决在rails2.0以上版本使用in_place_editor时出现的 ActionController::InvalidAuthenticityToken 错误。

Posted by devon At March 15, 2008 16:20
capture in view

<% @greeting = capture do %>
Welcome to my shiny new web page! The date and time is
<%= Time.now %>
<% end %> <%= @greeting %> The capture method allows you to extract part of a template into a variable. You can then use this variable anywhere in your templates or layout.

Posted by devon At March 13, 2008 14:06
在 before_filter 中使用不同的layout
before_filter Proc.new {|controller| layout 'iframe' unless controller.request.env["HTTP_REFERER"] =~ /localhost/ }
如果不是从localhost这个站点来访问的,则使用 iframe 的 layout

Posted by devon At March 11, 2008 17:38
Rails中获取 HTTP_REFERER
request.env["HTTP_REFERER"]
可以取到的参数包括:
SERVER_NAME: localhost
PATH_INFO: /forum/forums
HTTP_USER_AGENT: Mozilla/5.0 (Macintosh; U; Intel Mac OS X; en) AppleWebKit/522.11 (KHTML, like Gecko) Version/3.0.2 Safari/522.12
HTTP_ACCEPT_ENCODING: gzip, deflate
SCRIPT_NAME: /
SERVER_PROTOCOL: HTTP/1.1
HTTP_HOST: localhost:3000
HTTP_CACHE_CONTROL: max-age=0
HTTP_ACCEPT_LANGUAGE: en
REMOTE_ADDR: 127.0.0.1
SERVER_SOFTWARE: Mongrel 1.1.3
REQUEST_PATH: /forum/forums
HTTP_REFERER: http://localhost:3000/
HTTP_COOKIE: _matchsession=BAh7BzoMY3NyZl9pZCIlNWJiNzg4NDUzOWQzNWFhZTQ4MGRkNTUwYzc0MDc5%250AZGYiCmZsYXNoSUM6J0FjdGlvbkNvbnRyb2xsZXI6OkZsYXNoOjpGbGFzaEhh%250Ac2h7AAY6CkB1c2VkewA%253D268e6091590591d959128f3b17b62ff46244a0a3; _slemail=temp%40email.com; _slhash=9dfd86431742273e3e96e06a1c20541d69f74dc9; _haha_session=BAh7BiIKZmxhc2hJQzonQWN0aW9uQ29udHJvbGxlcjo6Rmxhc2g6OkZsYXNo%250ASGFzaHsABjoKQHVzZWR7AA%253D%253D--96565e41694dc839bd244af40b5d5121a923c8e3
HTTP_VERSION: HTTP/1.1
REQUEST_URI: /forum/forums
SERVER_PORT: "3000"
GATEWAY_INTERFACE: CGI/1.2
HTTP_ACCEPT: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5
HTTP_CONNECTION: keep-alive
REQUEST_METHOD: GET


推荐阅读
author-avatar
看非诚勿扰是修炼
这个家伙很懒,什么也没留下!
PHP1.CN | 中国最专业的PHP中文社区 | DevBox开发工具箱 | json解析格式化 |PHP资讯 | PHP教程 | 数据库技术 | 服务器技术 | 前端开发技术 | PHP框架 | 开发工具 | 在线工具
Copyright © 1998 - 2020 PHP1.CN. All Rights Reserved | 京公网安备 11010802041100号 | 京ICP备19059560号-4 | PHP1.CN 第一PHP社区 版权所有